9933
Comment: Correct Copyrght line to official syntax: the placement of (C)
|
5606
Make the script work even with set -o nounset (or set -u)
|
Deletions are marked like this. | Additions are marked like this. |
Line 5: | Line 5: |
Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses. |
Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses. |
Line 12: | Line 10: |
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this is the simplest approach (because you rarely need fancy stuff). | |
Line 13: | Line 12: |
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, it may suffice. Here's an example that will handle a combination of short (`-v`, `-h`) and long (`--verbose`, `--help`) options; and also style `--verbose=LEVEL`. |
This example will handle a combination of short and long options. Notice how both "--file" and "--file=FILE" are handled. |
Line 21: | Line 16: |
# # Copyright (C) 2012 Jari Aalto <jari.aalto@cante.net> # # This program is free; you can redistribute and/or modify it under # the terms of GNU General Public license either version 2 of the # License, or (at your option) any later version. |
# (POSIX shell syntax) |
Line 28: | Line 18: |
Help () { # To learn what TOP LEVEL sections to use in manual page, # see POSIX/Susv standard about "Utility Description Defaults" at # http://www.opengroup.org/onlinepubs/009695399/utilities/xcu_chap01.html#tag_01_11 |
set -o nounset # Reset all variables that might be set file= verbose=0 |
Line 34: | Line 23: |
echo " SYNOPSIS $0 [options] <argument> |
while [ "$#" -gt 0 ]; do case $1 in -h|-\?|--help) # Call a "show_help" function to display a synopsis, then exit. show_help exit ;; -f|--file) # Takes an option argument, ensuring it has been specified. if [ "$#" -gt 1 ]; then file=$2 shift 2 continue else echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2 exit 1 fi ;; --file=?*) file=${1#*=} # Delete everything up to "=" and assign the remainder. ;; --file=) # Handle the case of an empty --file= echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2 exit 1 ;; -v|--verbose) verbose=$((verbose + 1)) # Each -v argument adds 1 to verbosity. ;; --) # End of all options. shift break ;; -?*) printf 'WARN: Unknown option (ignored): %s\n' "$1" >&2 ;; *) # Default case: If no more options then break out of the loop. break esac |
Line 38: | Line 60: |
DESCRIPTION This program demonstrates use of options in shell scripts. Works in any POSIX compatible shell. |
shift done |
Line 42: | Line 63: |
OPTIONS -h, --help Display program help. |
# Suppose --file is a required option. Check that it has been set. if [ ! "$file" ]; then echo 'ERROR: option "--file FILE" not given. See --help.' >&2 exit 1 fi |
Line 46: | Line 69: |
-v, --verbose [LEVEL], --verbose=[LEVEL] Enable verbose messages. With optional LEVEL, increase verbosity. Allowed range is 1..9. " exit 0 } Warn () { echo "$*" >&2 } Die () { Warn "$*" exit 1 } Verbose () { [ "$verbose" ] || return 0 if [ $verbose_level -ge $1 ]; then shift echo "$*" fi } Main () { help="" # Reset all option variables that might be set later verbose="" verbose_level="" while : do case "$1" in -h | --help) help="help" shift # Remove from argument list Help ;; --verbose=*) # If you want to support --option=VALUE style verbose="verbose" verbose_level=${1#*=} # Delete everyting up till "=" shift ;; -v | --verbose) verbose="verbose" verbose_level=1 shift # Support "--verbose LEVEL" by reading next argument. case "$1" in [0-9]) verbose_level=$1 shift ;; esac ;; --) # End of all options shift break ;; -*) Warn "WARN: Unknown option: $1" shift ;; *) # no more options. Stop while loop break ;; esac done # Suppose, some options are required. Check that we got them [ "$verbose" ] || Die "ERROR: option --verbose not given. See --help" # Just to show how to display verbose messages from program Verbose 1 "Verbose is now SET to level $verbose_level" # <Rest of your code here> } Main "$@" # End of file |
# Rest of the program here. # If there are input files (for example) that follow the options, they # will remain in the "$@" positional parameters. |
Line 137: | Line 73: |
What is ''not possible'' to do with pure shell approach, is to try to parse separate options concatenaed together. Like like `-xvf` which would understoos as `-x -v -f`. This could be possible with lot of effort, but in practise it wouldn't be worth it. You may be interested in knowing that some Bash programmers like to write this at the beginning of their scripts to guard against unused variables: {{{ set -u # or, set -o nounset }}} |
This parser does not handle separate options concatenated together (like `-xvf` being understood as `-x -v -f`). This could be added with effort, but this is left as an exercise for the reader. |
Line 152: | Line 76: |
Unless it's the version from util-linux, and you use its advanced mode, '''never use getopt(1).''' Traditional versions of `getopt` cannot handle empty argument strings, or arguments with embedded whitespace. | |
Line 153: | Line 78: |
'''Never use getopt(1).''' `getopt` cannot handle empty arguments strings, or arguments with embedded whitespace. Please forget that it ever existed. The POSIX shell (and others) offer `getopts` which is safe to use instead. Here is a simplistic `getopts` example: |
The POSIX shell (and others) offer `getopts` which is safe to use instead. Here is a simplistic `getopts` example: |
Line 163: | Line 83: |
# A POSIX variable OPTIND=1 # Reset in case getopts has been used previously in the shell. |
# Usage info show_help() { cat << EOF Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]... Do stuff with FILE and write the result to standard output. With no FILE or when FILE is -, read standard input. |
Line 166: | Line 90: |
while getopts "h?vf:" opt; do | -h display this help and exit -f OUTFILE write the result to OUTFILE instead of standard output. -v verbose mode. Can be used multiple times for increased verbosity. EOF } # Initialize our own variables: output_file="" verbose=0 OPTIND=1 # Reset is necessary if getopts was used previously in the script. It is a good idea to make this local in a function. while getopts "hvf:" opt; do |
Line 168: | Line 104: |
h|\?) show_help exit 0 ;; v) verbose=1 ;; f) output_file=$OPTARG ;; |
h) show_help exit 0 ;; v) verbose=$((verbose+1)) ;; f) output_file=$OPTARG ;; '?') show_help >&2 exit 1 ;; |
Line 178: | Line 118: |
shift "$((OPTIND-1))" # Shift off the options and optional --. | |
Line 179: | Line 120: |
shift $((OPTIND-1)) [ "$1" = "--" ] && shift echo "verbose=$verbose, output_file='$output_file', Leftovers: $@" |
printf 'verbose=<%d>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file" printf '<%s>\n' "$@" |
Line 187: | Line 125: |
The advantages of `getopts` are: | |
Line 188: | Line 127: |
The disadvantage of `getopts` is that it can only handle short options (`-h`) without trickery. It handles `-vf filename` in the expected Unix way, automatically. `getopts` is a good candidate because it is portable and e.g. also works in dash. |
1. It's portable, and will work in any POSIX shell e.g. dash. 1. It can handle things like `-vf filename` in the expected Unix way, automatically. 1. It understands `--` as the option terminator and more generally makes sure, options are parsed like for any standard command. 1. With some implementations, the error messages will be localised in the language of the user. |
Line 193: | Line 132: |
There is a [[http://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. In bash, there is also `help getopts`, which might be informative. |
The disadvantage of `getopts` is that (except for ksh93 `getopts`) it can only handle short options (`-h`, not `--help`) without trickery and cannot handle options with optional arguments à la GNU. |
Line 198: | Line 134: |
There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all. |
There is a [[http://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. In bash, there is also `help getopts`, which might be informative. |
Line 207: | Line 136: |
Here is an example which parses long options with `getopts`. The basic idea is quite simple: just put "-:" into the optstring. This trick requires a shell which permits the option-argument (i.e. the filename in "-f filename") to be concatenated to the option (as in "-ffilename"). The [[http://pubs.opengroup.org/onlinepubs/9699919799/utilities/getopts.html|POSIX standard]] says there must be a space between them; bash and dash permit the "-ffilename" variant, but one should not rely on this leniency if attempting to write a portable script. |
There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all. |
Line 217: | Line 138: |
{{{#!highlight bash #!/bin/bash # Uses bash extensions. Not portable as written. optspec=":h-:" while getopts "$optspec" optchar do case "${optchar}" in -) case "${OPTARG}" in loglevel) eval val="\$${OPTIND}"; OPTIND=$(( $OPTIND + 1 )) echo "Parsing option: '--${OPTARG}', value: '${val}'" >&2 ;; loglevel=*) val=${OPTARG#*=} opt=${OPTARG%=$val} echo "Parsing option: '--${opt}', value: '${val}'" >&2 ;; esac ;; h) echo "usage: $0 [--loglevel[=]<value>]" >&2 exit 2 ;; esac done }}} === Silly repeated brute-force scanning === Another approach is to check options with `if` statements "on demand". A function like this one may be useful: {{{#!highlight bash #!/bin/bash HaveOpt () { local needle=$1 shift while [[ $1 == -* ]] do # By convention, "--" means end of options. case "$1" in --) return 1 ;; $needle) return 0 ;; esac shift done return 1 } HaveOpt --quick "$@" && echo "Option quick is set" # End of file }}} and it will work if script is run as: * YES: ./script --quick * YES: ./script -other --quick but will stop on first argument with no "-" in front (or on --): * NO: ./script -bar foo --quick * NO: ./script -bar -- --quick Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables. It also spreads the options throughout the program. The literal option `--quick` may appear a hundred lines down inside the main body of the program, nowhere near any other option name. This is a nightmare for maintenance. === Complex nonstandard add-on utilities === [[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code: {{{ PROG=$(basename $0) VERSION='1.2' USAGE="A tiny example using process-getopt(1)" # call process-getopt functions to define some options: source process-getopt SLOT="" SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option add_opt SLOT "boolean option" s "" slot TOKEN="" TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option add_opt TOKEN "this option takes a value" t n token number add_std_opts # define the standard options --help etc: TEMP=$(call_getopt "$@") || exit 1 eval set -- "$TEMP" # just as with getopt(1) # remove the options from the command line process_opts "$@" || shift "$?" echo "SLOT=$SLOT" echo "TOKEN=$TOKEN" echo "args=$@" }}} Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you. . ''Actually, what the author forgot to say was that it's actually using `getopts` semantics, rather than `getopt`. I ran this test:'' {{{ ~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'" ~/process-getopt-1.6$ call_getopt "$@" -- 'rm -rf /' 'foo;bar' ''\''' }}} . ''It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the [[BashFAQ/048|eval]] not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat '' ''It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for {{{getopt --test}}}) it only processes short options. It does not use the bash builtin getopts(1) command. -[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] '' |
For other, more complicated ways of option parsing, see ComplexOptionParsing. |
Line 348: | Line 142: |
---- CategoryBashguide CategoryBashguide |
How can I handle command-line arguments (options) to my script easily?
Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.
Contents
Manual loop
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this is the simplest approach (because you rarely need fancy stuff).
This example will handle a combination of short and long options. Notice how both "--file" and "--file=FILE" are handled.
1 #!/bin/sh
2 # (POSIX shell syntax)
3
4 set -o nounset
5 # Reset all variables that might be set
6 file=
7 verbose=0
8
9 while [ "$#" -gt 0 ]; do
10 case $1 in
11 -h|-\?|--help) # Call a "show_help" function to display a synopsis, then exit.
12 show_help
13 exit
14 ;;
15 -f|--file) # Takes an option argument, ensuring it has been specified.
16 if [ "$#" -gt 1 ]; then
17 file=$2
18 shift 2
19 continue
20 else
21 echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2
22 exit 1
23 fi
24 ;;
25 --file=?*)
26 file=${1#*=} # Delete everything up to "=" and assign the remainder.
27 ;;
28 --file=) # Handle the case of an empty --file=
29 echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2
30 exit 1
31 ;;
32 -v|--verbose)
33 verbose=$((verbose + 1)) # Each -v argument adds 1 to verbosity.
34 ;;
35 --) # End of all options.
36 shift
37 break
38 ;;
39 -?*)
40 printf 'WARN: Unknown option (ignored): %s\n' "$1" >&2
41 ;;
42 *) # Default case: If no more options then break out of the loop.
43 break
44 esac
45
46 shift
47 done
48
49 # Suppose --file is a required option. Check that it has been set.
50 if [ ! "$file" ]; then
51 echo 'ERROR: option "--file FILE" not given. See --help.' >&2
52 exit 1
53 fi
54
55 # Rest of the program here.
56 # If there are input files (for example) that follow the options, they
57 # will remain in the "$@" positional parameters.
This parser does not handle separate options concatenated together (like -xvf being understood as -x -v -f). This could be added with effort, but this is left as an exercise for the reader.
getopts
Unless it's the version from util-linux, and you use its advanced mode, never use getopt(1). Traditional versions of getopt cannot handle empty argument strings, or arguments with embedded whitespace.
The POSIX shell (and others) offer getopts which is safe to use instead. Here is a simplistic getopts example:
1 #!/bin/sh
2
3 # Usage info
4 show_help() {
5 cat << EOF
6 Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
7 Do stuff with FILE and write the result to standard output. With no FILE
8 or when FILE is -, read standard input.
9
10 -h display this help and exit
11 -f OUTFILE write the result to OUTFILE instead of standard output.
12 -v verbose mode. Can be used multiple times for increased
13 verbosity.
14 EOF
15 }
16
17 # Initialize our own variables:
18 output_file=""
19 verbose=0
20
21 OPTIND=1 # Reset is necessary if getopts was used previously in the script. It is a good idea to make this local in a function.
22 while getopts "hvf:" opt; do
23 case "$opt" in
24 h)
25 show_help
26 exit 0
27 ;;
28 v) verbose=$((verbose+1))
29 ;;
30 f) output_file=$OPTARG
31 ;;
32 '?')
33 show_help >&2
34 exit 1
35 ;;
36 esac
37 done
38 shift "$((OPTIND-1))" # Shift off the options and optional --.
39
40 printf 'verbose=<%d>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
41 printf '<%s>\n' "$@"
42
43 # End of file
The advantages of getopts are:
- It's portable, and will work in any POSIX shell e.g. dash.
It can handle things like -vf filename in the expected Unix way, automatically.
It understands -- as the option terminator and more generally makes sure, options are parsed like for any standard command.
- With some implementations, the error messages will be localised in the language of the user.
The disadvantage of getopts is that (except for ksh93 getopts) it can only handle short options (-h, not --help) without trickery and cannot handle options with optional arguments à la GNU.
There is a getopts tutorial which explains what all of the syntax and variables mean. In bash, there is also help getopts, which might be informative.
There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to getopts, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all.
For other, more complicated ways of option parsing, see ComplexOptionParsing.